﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommandDesignPattern
{
    
    interface ICommand
    {
        void Execute();
        void UnExecute();
    }


    class CalculationCommand : ICommand
    {
        private char _operator;
        private int _operand;
        private Calculator _calculator;

        // Constructor
        public CalculationCommand(Calculator calculator,
          char @operator, int operand)
        {
            this._calculator = calculator;
            this._operator = @operator;
            this._operand = operand;
        }

        // Gets operator
        public char Operator
        {
            set { _operator = value; }
        }

        // Get operand
        public int Operand
        {
            set { _operand = value; }
        }

        // Execute new command
        public  void Execute()
        {
            _calculator.Operation(_operator, _operand);
        }

        // Unexecute last command
        public  void UnExecute()
        {
            _calculator.Operation(Undo(_operator), _operand);
        }

        // Returns opposite operator for given operator
        private char Undo(char @operator)
        {
            switch (@operator)
            {
                case '+': return '-';
                case '-': return '+';
                case '*': return '/';
                case '/': return '*';
                default: throw new
                 ArgumentException("@operator");
            }
        }
    }
}
